% ### EXloess1.m ###     10.12.14
% Determine loess fit to a set of randomly-generated noisy data

% Note: Requires loess.m

clear; figure(1); clf;
% -----------------------------
% User Inputs

N= 100;     % # of points for fit (over interval [min(x) max(x)])
xR= [0 1];  % range of x-values
scaleN= 0.1;    % scale factor for noise

alpha= 0.2;     % loess fit parameter (between 0 and 1)
order= 1;        % order of polynomial for fit

% -------------------------------------------------
x= linspace(min(xR),max(xR),N); % determine fit x-values
polyS= ceil(10*rand(1));   % randomly determine polynomial order
Pv= 2*rand(polyS,1)-1;  % polynomial coefficients
y= polyval(Pv,x)+ rand(1)*sin(2*pi*x)+ scaleN*randn(N,1)'; % pseudo-random 'data'

% ---
xFit= linspace(min(xR),max(xR),N); % can 'resample' if desired (i.e., need not have xFit=x)
yFit= loess(x,y,xFit,alpha,order,[],1,0,0.1);   % loess fit via external function

% ---
% visualize
plot(x,y,'ko'); hold on; grid on;
plot(xFit,yFit,'r-','LineWidth',2);
xlabel('x'); ylabel('y');
legend('original data','loess trend','Location','NorthWest');
